import traders
import book
import random
import math
## the model module set up the model


class Model():

    def __init__(self, numberofBuyers, numberofSellers, value, cost):

        self.nB = numberofBuyers
        self.nS = numberofSellers

        self.cost = cost
        self.value = value     
        self.traderList = []

    def buildModel(self):

        self.b = book.Book()

        for i in range(self.nB):
            t = traders.BuyerTrader(self.value[i])
            self.traderList.append(t)
         
        for i in range(self.nS):

            t = traders.SellerTrader(self.cost[i])
            self.traderList.append(t)
        

         
    def runModel(self, tick):

         random.shuffle(self.traderList)
         ## every period every trader has to transact -- resampling mechanism

         for i in self.traderList:
             i.trade(tick, self.b)
          
