## observer module. Here I build the model and run it and observe the results.
## the tick by tick results and the perios by period results are stored in the book

import model
import rpy


class Observer():

    def __init__(self, numberofPeriods, numberofBuyers, numberofSellers, cost, value):

        self.nP = numberofPeriods
        self.nB = numberofBuyers
        self.nS = numberofSellers
        self.cost = cost
        self.value=value

        self.m = model.Model(self.nB, self.nS, self.value, self.cost)
        self.m.buildModel()

        ## graphical variables
        self.price=[]
        self.equilibrium=[]
    def startModel(self):

        ## I run the model for nP periods

        for time in range(self.nP):

            self.m.runModel(time)

        ## at the end of each period I print the last market Price
            if len(self.m.b.marketPrice)>0:
              self.price.append(self.m.b.marketPrice[len(self.m.b.marketPrice)-1])
              self.equilibrium.append(90)

            if len(self.price)>0: 
             rpy.r.plot(self.price, ylab='Price', type='l', ylim = (0,200))
             rpy.r.lines(self.equilibrium, col = 'red')
